CREATE PROCEDURE dbo.KitchenSink_Chaos
  @CustomerID INT  = NULL,
  @OrderDate  DATE = NULL,
  @ShipDate   DATE = NULL,
  @status     TINYINT = NULL
  -- , ... other parameters ...
AS
BEGIN
  SET NOCOUNT ON;

  SELECT SalesOrderID --, ... other columns ...
    FROM Sales.SalesOrderHeaderEnlarged
	WHERE CustomerID = COALESCE(@CustomerID, CustomerID)
	  AND OrderDate = COALESCE(@OrderDate, OrderDate)
	  AND (ShipDate = @ShipDate OR @ShipDate IS NULL) -- nullable
	  AND [status] = COALESCE(@status, [status])
	  -- AND ... other conditional clauses ...
	  ;
END
GO

CREATE PROCEDURE dbo.KitchenSink_LessChaos
  @CustomerID INT  = NULL,
  @OrderDate  DATE = NULL,
  @ShipDate   DATE = NULL,
  @status     TINYINT = NULL
  -- , ... other parameters ...
AS
BEGIN
  SET NOCOUNT ON;

  DECLARE @sql NVARCHAR(MAX) = N'SELECT SalesOrderID
    -- , ... other columns ...
    FROM Sales.SalesOrderHeaderEnlarged WHERE 1 = 1';

  SET @sql += CASE WHEN @CustomerID IS NOT NULL 
	  THEN N' AND CustomerID = @CustomerID' ELSE '' END
	+ CASE WHEN @OrderDate IS NOT NULL 
	  THEN N' AND OrderDate = @OrderDate' ELSE '' END
    + CASE WHEN @ShipDate IS NOT NULL
	  THEN N' AND ShipDate = @ShipDate' ELSE '' END
	+ CASE WHEN @status IS NOT NULL 
	  THEN N' AND [status] = @status' ELSE '' END;

  --SET @sql += N' OPTION (RECOMPILE)';

  EXEC sp_executesql @sql, 
    N'@CustomerID INT, @OrderDate DATE, @ShipDate DATE, @status TINYINT',
	@CustomerID, @OrderDate, @ShipDate, @status;
END
GO

CREATE PROCEDURE dbo.KitchenSink_BadDynamicSQL
  @CustomerID INT  = NULL,
  @OrderDate  DATE = NULL,
  @ShipDate   DATE = NULL,
  @status     TINYINT = NULL
  -- , ... other parameters ...
AS
BEGIN
  SET NOCOUNT ON;

  DECLARE @sql NVARCHAR(MAX) = N'SELECT SalesOrderID
    -- , ... other columns ...
    FROM Sales.SalesOrderHeaderEnlarged WHERE 1 = 1';

  IF @CustomerID IS NOT NULL
    SET @sql += N' AND CustomerID = ' + CONVERT(VARCHAR(12), @CustomerID);

  IF @OrderDate IS NOT NULL
    SET @sql += N' AND OrderDate = ''' + CONVERT(CHAR(8), @OrderDate, 112) + '''';

  IF @ShipDate IS NOT NULL
    SET @sql += N' AND ShipDate = ''' + CONVERT(CHAR(8), @ShipDate, 112) + '''';

  IF @status IS NOT NULL
    SET @sql += N' AND [status] = ''' + CONVERT(VARCHAR(3), @status) + '''';

  -- if we had a last name, for example, we'd have to do the really ugly:
  -- += N' AND LastName = N''' + REPLACE(@LastName, '''', '''''') + '''';

  EXEC(@sql);
END
GO